{ =========================================================================== }
{                                   MM.PAS                                    }
{ =========================================================================== }

program MM;

{ ---> Mostra uma matriz salva no  disco na tela com  a  quantidade de casas
       decimais desejada                                                      }

{$E+,N+,R-,S-,B-}

uses
  FPTCBAs, Matrizes, Crt;

const
  mens: array[1..11] of string[80] =
  ('          Ŀ',
   '                                                                      ',
   '             Forma de usar  MM matriz decimais                       ',
   '                                                                      ',
   '             onde                                                     ',
   '                                                                      ',
   '                  decimais = quantidade de casas decimais             ',
   '                                                                      ',
   '             Exemplo  MM mat1 15                                     ',
   '                                                                      ',
   '          ');

{ --------------------------------------------------------------------------- }

procedure MolduraMM(nome: string; x, y: byte);

var
  posicao, i: byte;
  linha, col, ordem: string[40];

begin
  while (nome[1] = ' ') do nome := Copy(nome, 2, Length(nome));
  nome := Maiusculas(nome);
  Str(x, linha); Str(y, col);
  ordem := ' MATRIZ ' + nome + ' ' + linha + ' x '  + col + ' ';
  Cls; Window(1, 1, 79, 24); Cor(2, 6); ClrScr;
  Write(#213, Repete(77, #205), #184);
  posicao := (78 - Length(ordem)) div 2;
  GoToXY(posicao, 1); Write(ordem);
  for i := 2 to 23 do
  begin
    GoToXY(1, i); Write(#179);
    GoToXY(79, i); Write(#179);
  end;
  GoToXY(1, 23);
  Write(#212, Repete(77, #205), #190);
  Window(1, 24, 79, 24); Cor(7, 0); ClrScr;
  GoToXY(2, 1); Write(#26,' : Prox.col.');
  GoToXY(17, 1); Write(#27,' : Col.anter.');
  GoToXY(34, 1); Write('Home : Prim.col.');
  GoToXY(52, 1); Write('End : Ultim.col.');
  GoToXY(70, 1); Write('ESC : Fim');
  Window(2, 2, 78, 22); Cor(2, 0);
end;

{ --------------------------------------------------------------------------- }

procedure MostraColunasDaMatriz(mat: matriz; tam1, tam2, ColunaInicial,
                                                                  quant: byte);

var
  esp1, esp2, i, j: byte;
  aux, mens, linha: string[80];

begin
  Cor(2, 7);
  if (mat.m < 19) then esp1 := 1 else esp1 := 0;
  linha := ''; GoToXY(1, esp1 + 1);
  for i := 1 to quant do
  begin
    Str(ColunaInicial + i - 1, aux);
    mens := 'col. '  + aux;
    linha := linha + Spc(tam1 - Length(mens)) + mens;
  end;
  Write(linha); Cor(2, 0);
  if (mat.m < 20) then esp2 := esp1 + 1 else esp2 := esp1;
  for i := 1 to mat.m do
  begin
    GoToXY(1, i + esp2 + 1);
    for j := ColunaInicial to ColunaInicial + quant - 1 do
      Write(mat.a[i, j]:tam1:tam2);
  end;
end;

{ --------------------------------------------------------------------------- }

var
  ColunaInicial, quant, i, d, tam1, tam2: byte;
  cod: integer;
  nome, decimais: string[15];
  mat: matriz;
  erro: boolean;
  ch: char;

begin
  ClrScr;
  if (ParamCount < 2) then
  begin
    nome := ' ';
    decimais := ' ';
  end
  else
  begin
    nome := ParamStr(1);
    decimais := ParamStr(2);
  end;
  Val(decimais, d, cod);
  if ((cod <> 0) or (ParamCount < 2)) then
  begin
    Writeln(#7);
    for i := 1 to 11 do Writeln(mens[i]);
    Halt;
  end;
  erro := false;
  if (d > 20) then d := 20 else if (d < 2) then d := 2;
  LeMatrizDisco(mat, nome, erro);
  if erro then
  begin
    Writeln; Writeln(#7, '*** ERRO DE LEITURA ***');
    Writeln; Halt;
  end;
  FormataMatriz(mat, tam1, tam2);
  if tam2 > 0 then
  begin
    tam1 := 1 + tam1 - tam2 + d;
    tam2 := d;
  end;
  if (tam1 < 10) then tam1 := 10;
  quant := 75 div tam1;
  if (quant > mat.n) then quant := mat.n;
  ColunaInicial := 1;
  MolduraMM(nome, mat.m, mat.n);
  MostraColunasDaMatriz(mat, tam1, tam2, ColunaInicial, quant);
  repeat
    ch := ReadKey;
    if (ch = #0) then
    begin
      ch := ReadKey;
      case ch of
        Home: ColunaInicial := 1;
        TeclaEnd: ColunaInicial := mat.n - quant + 1;
        SetaPDireita:
          if (ColunaInicial <= mat.n - quant) then
            Inc(ColunaInicial)
          else
            Write(#7);
        SetaPEsquerda:
          if (ColunaInicial >= 2) then Dec(ColunaInicial) else Write(#7);
      end;
      MostraColunasDaMatriz(mat, tam1, tam2, ColunaInicial, quant);
    end;
  until (ch = ESC);
  Cls;
end.

{ =========================================================================== }

