{ =========================================================================== }
{                                    MT.PAS                                   }
{ =========================================================================== }

program MT;

{ ---> mostra na telas arquivos de texto                                      }

{$E+,N+,B-,F+,S+,R+}

{$M 65520, 0, 655200}

uses
  Crt, FPTCBas;

const
  LPPag = 22;  { quantidade de linhas por pagina mostradas   }
  MaxL = 700;  { quantidade maxima de linhas lida no arquivo }

type
  MatTexto = array[1..MaxL] of string[83];
  TextoPtr = ^MatTexto;

const
  mens: array[1..7] of string[80] =
  ('          Ŀ',
   '                                                                      ',
   '             Forma de usar  MT NomeDoArquivoDeTexto                  ',
   '                                                                      ',
   '             Exemplo  MT EQDEMO.DOC                                  ',
   '                                                                      ',
   '          ');

{ --------------------------------------------------------------------------- }

procedure MostraTexto(arq: string; x: TextoPtr; linha,
                                  CorDeFundo, CorDoTexto, TotalDeLinhas: word);
var
  i: word;

begin
  TextColor(CorDoTexto);
  TextBackGround(CorDeFundo);
  ClrScr;
  i := linha;
  repeat
    Writeln(x^[i]);
    if (i < TotalDeLinhas) then Inc(i);
  until ((i > linha + LPPag - 1) or (i > MaxL) or (i = TotalDeLinhas));
end;

{ --------------------------------------------------------------------------- }

procedure MostraTelasDoc(nome: string);

var
  arq: text;
  x: TextoPtr;
  TotalDeLinhas, linha: integer;
  ch: char;
  espacos, CorDeFundo, CorDoTexto: byte;
  l: string[90];

begin
  Cls; New(x);
  linha := 1;
  Assign(arq, nome);
  Reset(arq);
  repeat
    Readln(arq, x^[linha]);
    Inc(linha);
  until (Eof(arq) or (linha > MaxL));
  Close(arq);
  Window(1, 1, 80, 1); Cor(7, 0);
  espacos := (79 - Length(nome)) div 2;
  ClrScr; Write(Spc(espacos), nome);
  Window(1, 25, 80, 25); ClrScr;
  Write(Spc(12),
  'Pressione  ', #24,', ',  #25, ', PgUp, PgDn, Home, End, F5, F6 ou ESC');
  Window(1, 2, 80, 24);
  if (linha > MaxL) then
    TotalDeLinhas := MaxL
  else
    TotalDeLinhas := linha - 1;
  linha := 1; CorDeFundo := 2; CorDoTexto := 0;
  MostraTexto(nome, x, linha, CorDeFundo, CorDoTexto, TotalDeLinhas);
  repeat
    ch := ReadKey;
    if (ch = #0) then
    begin
      ch := ReadKey;
      case ch of
        Home:
          linha := 1;
        TeclaEnd:
          linha := TotalDeLinhas - LPPag;
        SetaPBaixo:
          if (linha < TotalDeLinhas) then Inc(linha);
        SetaPCima:
          if (linha >= 2) then Dec(linha);
        PgDn:
          if (linha + LPPag < TotalDeLinhas) then
            Inc(linha, LPPag)
          else
            linha := TotalDeLinhas - LPPag - 1;
        PgUp:
          if (linha > LPPag) then Dec(linha, LPPag) else linha := 1;
        F5: if CorDeFundo = 15 then CorDeFundo := 0 else Inc(CorDeFundo);
        F6: if CorDoTexto = 15 then CorDoTexto := 0 else Inc(CorDoTexto);
      end;
    end;
    if (ch <> ESC) then
      MostraTexto(nome, x, linha, CorDeFundo, CorDoTexto, TotalDeLinhas);
  until (ch = ESC);
  Dispose(x);
  Window(1, 25, 79, 25); Cor(7, 0); ClrScr;
  Window(1, 24, 79, 24);
end;

{ --------------------------------------------------------------------------- }

var
  i: byte;
  arq: string;

begin
  if (ParamCount = 0) then
  begin
    Writeln(#7);
    for i := 1 to 7 do Writeln(mens[i]);
    Writeln;
    Halt;
  end;
  arq := Maiusculas(ParamStr(1));
  MostraTelasDoc(arq);
end.

{ =========================================================================== }

